// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "resource.h"
#include <afxdllx.h>
#include <math.h>
#include <Imm.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE XkeymacsdllDLL = { NULL, NULL };

static HINSTANCE g_hDllInst = NULL;

HINSTANCE GetThisHInst()
{
	return g_hDllInst;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	g_hDllInst = hInstance;
	
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("XKEYMACSDLL.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsdllDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(XkeymacsdllDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("XKEYMACSDLL.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsdllDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsDll.h"
#pragma data_seg(".xkeymacs")
	HHOOK	CXkeymacsDll::m_hHook = NULL;
	int		CXkeymacsDll::m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	char	CXkeymacsDll::m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH] = {'\0'};
	HWND	CXkeymacsDll::m_hPrevWnd = 0;
	OSVERSIONINFO CXkeymacsDll::m_OsVersionInfo;
	SEARCH_DIRECTION CXkeymacsDll::m_CurrentDirection = NA;
	BOOL	CXkeymacsDll::m_bRightControl	= FALSE;
	BOOL	CXkeymacsDll::m_bRightAlt		= FALSE;
	BOOL	CXkeymacsDll::m_bRightShift		= FALSE;
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsDll::CXkeymacsDll()
{

}

CXkeymacsDll::~CXkeymacsDll()
{

}


// set keyboard hook
BOOL CXkeymacsDll::SetKeyboardHook()
{
	m_hHook = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, GetThisHInst(), 0);

	if(!m_hHook)
		return FALSE;

	return TRUE;
}

// release keyboard hook
BOOL CXkeymacsDll::ReleaseKeyboardHook()
{
	BOOL bRes = TRUE;

	if(m_hHook)
		bRes = ::UnhookWindowsHookEx(m_hHook);

	m_hHook = NULL;
	return bRes;
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
	if (m_hHook)
		return TRUE;

	return FALSE;
}

// return true if the key is down
inline BOOL CXkeymacsDll::IsDown(BYTE bVk)
{
	return (GetKeyState(bVk) < 0);
}

// Do keybd_event
void CXkeymacsDll::DoKeybd_event(BYTE bVk, DWORD dwFlags)
{
	// Set KEYEVENTF_EXTENDEDKEY if needed
	switch (bVk) {
	case VK_CONTROL:
		if (m_bRightControl)	// Right Ctrl
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_MENU:
		if (m_bRightAlt)		// Right Alt
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_SHIFT:
		if (m_bRightShift)		// Right Shift
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_PAUSE:
		if (IsDown(VK_CONTROL))	// Break
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_NEXT:
	case VK_PRIOR:
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:
	case VK_LEFT:
	case VK_NUMLOCK:
	case VK_PRINT:
		dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	default:
		break;
	}

	keybd_event(bVk, MapVirtualKey(bVk, 0), dwFlags, 0);
}

// the key is being depressed
inline void CXkeymacsDll::DepressKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, 0);
}

// the key is being released
inline void CXkeymacsDll::ReleaseKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, KEYEVENTF_KEYUP);
}

// bVk down, bVk up
inline void CXkeymacsDll::Kdu(BYTE bVk, int n = 1)
{
	if (n == 0)
		n = 1;
	while (n--) {
		DepressKey(bVk);
		ReleaseKey(bVk);
	}
}

// control up, bVk down and bVk up n times (at least 1 times), control down
inline void CXkeymacsDll::CuKduCd(BYTE bVk, int n = 1)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );

	ReleaseKey(VK_CONTROL);
	Kdu(bVk, n);
	DepressKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );
}

inline void CXkeymacsDll::CuKduKduCd(BYTE bVk1, BYTE bVk2)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );

	ReleaseKey(VK_CONTROL);
	Kdu(bVk1);
	Kdu(bVk2);
	DepressKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );
}

// if control is down: control up, atl down, bVk down, bVk up, alt up, control down
inline void CXkeymacsDll::CuAdKduAuCd(BYTE bVk)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, alt up, control down
inline void CXkeymacsDll::CuAdKduKduAuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, ...,  bVk3 down, bVk3 up, alt up, control down
inline void CXkeymacsDll::CuAdKduKduKduAuCd(BYTE bVk1, BYTE bVk2, BYTE bVk3)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	Kdu(bVk3);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk down, bVk up, shift up, control down
inline void CXkeymacsDll::CuSdKduSuCd(BYTE bVk)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, shift up, control down
inline void CXkeymacsDll::CuSdKduKduSuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// alt up, bVk down, bVk up, alt down
inline void CXkeymacsDll::AuKduAd(BYTE bVk)
{
	ReleaseKey(VK_MENU);
	Kdu(bVk);
	DepressKey(VK_MENU);
}

// alt up, control down, bVk down, bVk up, control up, alt down
inline void CXkeymacsDll::CdKduCu(BYTE bVk, int n = 1)
{
	DepressKey(VK_CONTROL);
	Kdu(bVk, n);
	ReleaseKey(VK_CONTROL);
}

inline BOOL CXkeymacsDll::CopyBackCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	CuSdKduSuCd(VK_LEFT);
	Kdu('C');
	CuKduCd(VK_RIGHT);

	return TRUE;
}

// Copy next character of the cursor
inline BOOL CXkeymacsDll::CopyNextCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	CuSdKduSuCd(VK_RIGHT);
	Kdu('C');
	CuKduCd(VK_LEFT);

	return TRUE;
}

// control up, VK_KANJI down, VK_KANJI up, control down
inline void CXkeymacsDll::ToggleIME()
{
	HWND hWnd = GetFocus();
	HIMC hIMC = ImmGetContext(hWnd);
	ImmSetOpenStatus(hIMC, !ImmGetOpenStatus(hIMC));
	ImmReleaseContext(hWnd, hIMC);
}

CSearchKey::CSearchKey()
{
	bFindWhat			= 'N';
	bDirectionForward	= 'D';
	bDirectionBackward	= 'U';
	bSearchOption		= 0;
}

CSearchKey::CSearchKey(char *szApplicationName, int nApplicationNameLength, CString *szDialogTitle)
{
	bFindWhat			= 'N';
	bDirectionForward	= 'D';
	bDirectionBackward	= 'U';
	bSearchOption		= 0;

	if (!strnicmp(szApplicationName, "wordpad.exe", nApplicationNameLength) ||
		!strnicmp(szApplicationName, "123w.exe", nApplicationNameLength)) {
		bDirectionForward = bDirectionBackward = 0;
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		bFindWhat			= 'F';
		bDirectionForward	= 'D';
		bDirectionBackward	= 'B';
		bSearchOption		= 'O';
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		bFindWhat			= 'F';
		if (!szDialogTitle->Compare("{")) {
			bDirectionForward	= 'O';
			bDirectionBackward	= 'B';
		} else {
			bDirectionForward	= 0;
			bDirectionBackward	= 0;
		}
	} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
		bFindWhat			= 0;
		bDirectionForward	= 'D';
		bDirectionBackward	= 'U';
	} else if (!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
		bFindWhat			= 'S';
		bDirectionForward	= 'N';
		bDirectionBackward	= 'P';
	}

	if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
		!szDialogTitle->Compare("Find")) {
		// Outlook (English version)
		bDirectionForward = bDirectionBackward = 0;
	}
}

CSearch::CSearch(char* szApplicationName, int nApplicationNameLength)
{
	{
		char buf[0x100];
		memset(buf, 0, sizeof(buf));
		if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "msdev.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
			// Becky!, hidemaru, VC++, sakura
			GetWindowText(GetParent(GetParent(GetFocus())), buf, sizeof(buf));

			// This it not use for hidemaru and sakura.
			// If use this, keyboard hook will be released.
//			AfxGetApp()->m_pMainWnd->GetFocus()->GetParent()->GetParent()->GetWindowText(szDialogTitle);
		} else {
			// default
			GetWindowText(GetParent(GetFocus()), buf, sizeof(buf));
//			AfxGetApp()->m_pMainWnd->GetFocus()->GetParent()->GetWindowText(szDialogTitle);
		}
		szDialogTitle.Format("%s", buf);
	}

//	CString sz;
//	sz.Format("A%sA", szDialogTitle);
//	AfxMessageBox(sz);
//	AfxMessageBox(szDialogTitle);

	if (!szDialogTitle.Compare("") ||				// notepad, wordpad, IE, regedit, 
														// Excel, Front Page, PowerPoint, Acrobat Reader, IBM HPB
		!szDialogTitle.Compare("Find") ||				// notepad, Outlook, Outlook Express, Opera
		!szDialogTitle.Compare("{") ||			// Becky!
		!szDialogTitle.Compare("[") ||			// Becky!
		!szDialogTitle.Compare("̌") ||		// M$ VC++
		!szDialogTitle.Compare("ƒu") ||			// M$ Word, 123
		!szDialogTitle.Compare("̃eLXǧ")	// Lotus Notes
		) {
//		AfxMessageBox("FALSE");
	} else {
		szDialogTitle.Empty();
//		AfxMessageBox("TRUE");
	}

	pKey = new CSearchKey(szApplicationName, nApplicationNameLength, &szDialogTitle);
}

inline void CXkeymacsDll::SearchSetDirection(SEARCH_DIRECTION direction, char *szApplicationName,
											 int nApplicationNameLength, BOOL *bOriginalM_b, BOOL *bOriginalM_f,
											 CSearch *pSearch)
{
	if ((direction != FORWARD) && (direction != BACKWARD))
		ASSERT(0);

	if (pSearch->pKey->bDirectionForward == 0 && pSearch->pKey->bDirectionBackward == 0)
		return;
	else if (!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength)) {
		// Microsoft Word
		CuAdKduAuCd('M');
		CuAdKduAuCd(VK_OEM_1);	// 0xBA Used for miscellaneous characters; it can vary by keyboard. 
								//		Windows 2000/XP: For the US standard keyboard, the ';:' key
		CuKduKduCd(VK_UP, VK_UP);
		if (direction == BACKWARD)
			CuKduCd(VK_DOWN);
		CuAdKduAuCd('N');
		CuKduCd(VK_ESCAPE);
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		BYTE bDirection	= 0;

		if (direction == FORWARD)
			bDirection = pSearch->pKey->bDirectionForward;
		else if (direction == BACKWARD)
			bDirection = pSearch->pKey->bDirectionBackward;

		if (bDirection == 'B')
			*bOriginalM_b = TRUE;
		CuAdKduKduKduAuCd(pSearch->pKey->bSearchOption, bDirection, pSearch->pKey->bSearchOption);
		CuSdKduKduSuCd(VK_TAB, VK_TAB);
		CuKduCd(VK_END);
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		CuAdKduAuCd(pSearch->pKey->bDirectionForward);
		if (direction == BACKWARD)
			CuKduCd(VK_UP);
		CuKduCd(VK_TAB, 4);
		CuKduCd(VK_END);
	} else {
		// default
		BYTE bDirection	= 0;
	
		if (direction == FORWARD)
			bDirection = pSearch->pKey->bDirectionForward;
		else if (direction == BACKWARD)
			bDirection = pSearch->pKey->bDirectionBackward;

		if (pSearch->pKey->bFindWhat == 'F')
			*bOriginalM_f = TRUE;
		if (bDirection == 'B')
			*bOriginalM_b = TRUE;
//		CString sz;
//		sz.Format("%c, %c", bDirection, pSearch->pKey->bFindWhat);
//		AfxMessageBox(sz);
		CuAdKduKduAuCd(bDirection, pSearch->pKey->bFindWhat);
	}
}

inline void CXkeymacsDll::Search(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength,
								 BOOL *bOriginalC_f, BOOL *bOriginalM_b, BOOL *bOriginalM_f)
{
	if ((direction != FORWARD) && (direction != BACKWARD))
		ASSERT(0);

	CSearch *pSearch;
	pSearch = new CSearch(szApplicationName, nApplicationNameLength);

	if (pSearch->szDialogTitle.IsEmpty()) {
		// Find Dialog is not.
		// Open Find dialog
		if ((!strnicmp(szApplicationName, "notepad.exe", nApplicationNameLength)) &&
			((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) ||
			 ((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) &&
			  (m_OsVersionInfo.dwMajorVersion <= 4)))) {
			// notepad on Win9x or NT
			*bOriginalM_f = TRUE;
			CuAdKduKduAuCd('S', 'F');
		} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
			// sakura
			CuAdKduKduAuCd('S', VK_RETURN);
		} else if (!strnicmp(szApplicationName, "msimn.exe", nApplicationNameLength)) {
			CuKduCd(VK_F3);
		} else if (!strnicmp(szApplicationName, "opera.exe", nApplicationNameLength) ||
				   !strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			*bOriginalC_f = TRUE;
			Kdu('F');
		} else {
			// default
//			*bOriginalC_f = TRUE;
//			Kdu('F');
			*bOriginalM_f = TRUE;
			CuAdKduKduAuCd('E', 'F');
		}

		// Set Direction w/o with sakura.exe if Find dialog already exist
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "wordpro.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			// sakura, wordpro
		} else if (!strnicmp(szApplicationName, "iexplore.exe", nApplicationNameLength)) {
			// IE
			// I want to set direction but IE does not allow me.
		} else {
			// default
			SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
							   bOriginalM_b, bOriginalM_f, pSearch);
		}
		m_CurrentDirection = direction;
	} else {
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			BYTE bDirection = 0;

			if (direction == FORWARD)
				bDirection = pSearch->pKey->bDirectionForward;
			else if (direction == BACKWARD)
				bDirection = pSearch->pKey->bDirectionBackward;
			else
				ASSERT(0);
			CuAdKduAuCd(bDirection);
		} else {
			if (m_CurrentDirection != direction) {
				// Set Direction if Find dialog already exist
				SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
								   bOriginalM_b, bOriginalM_f, pSearch);
				m_CurrentDirection = direction;
				return;
			}

			// "Find Next(F)" if Find dialog already exist
			CuKduCd(VK_RETURN);

			// open Find dialog again
			if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
				pSearch->szDialogTitle.Compare("")) {
				// Outlook (w/o Japanese version)
				*bOriginalM_f = TRUE;
				CuAdKduKduAuCd('E', 'F');
			} else if (!strnicmp(szApplicationName, "msdev.exe", nApplicationNameLength)) {
				// Visual C++
				*bOriginalC_f = TRUE;
				Kdu('F');
			} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
				// Becky!
//				*bOriginalM_f = TRUE;
//				CuAdKduKduAuCd('E', 'F');
//				*bOriginalC_f = TRUE;
//				Kdu('F');
			}

			// set cursor at end of FindWhat
			if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
//				CuKduCd(VK_TAB, 4);
//				CuKduCd(VK_DOWN);
			} else {
				if (pSearch->pKey->bFindWhat == 'F')
					*bOriginalM_f = TRUE;
				CuAdKduAuCd(pSearch->pKey->bFindWhat);
				if(!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength))
					CuKduCd(VK_ESCAPE);
			}
			CuKduCd(VK_END);
		}
	}
	delete pSearch;
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::KeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
/** /
	{
		// Show key code
		CString sz;
		sz.Format("%c: 0x%x", wParam, wParam);
		AfxMessageBox(sz);
	}
/**/

	static BOOL	bC_x		 = FALSE;
	static BOOL bM_			 = FALSE;
	static BOOL bOriginalC_f = FALSE;
	static BOOL bOriginalC_o = FALSE;
	static BOOL bOriginalC_v = FALSE;
	static BOOL bOriginalC_x = FALSE;
	static BOOL bOriginalC_z = FALSE;
	static BOOL bOriginalM_b = FALSE;
	static BOOL bOriginalM_f = FALSE;
	static int	nRepeat		 = 0;
	HWND hCurrentWnd = GetFocus();
	static char szApplicationName[MAX_PATH];
	static int nApp = 0;

	if (code < 0 || code == HC_NOREMOVE)
		goto DO_NOTHING;

	if (lParam & 0x80000000)
		goto DO_NOTHING;

	if (m_hPrevWnd != hCurrentWnd) {
		CString szApplicationNameOrg = szApplicationName;

		GetModuleFileName(NULL, szApplicationName, sizeof(szApplicationName));
		CString szFn(szApplicationName);
		szFn.Delete(0, szFn.ReverseFind('\\') + 1);
		ZeroMemory(szApplicationName, sizeof(szApplicationName));
		strncpy(szApplicationName, szFn, szFn.GetLength());

		if (strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
			for (nApp = 0; nApp < MAX_APP; nApp++) {
				if (!strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
					break;
				}
			}
			if (nApp == MAX_APP) {
				for (nApp = 0; nApp < MAX_APP; nApp++) {
					CString szDefault(IDS_DEFAULT);	// Is it work correct??? Delete! Use only static function. i.e. do not use string resource
					if (!strnicmp(m_szSpecialApp[nApp], szDefault, sizeof(szApplicationName))) {
						break;
					}
				}
				if (nApp == MAX_APP)
					nApp = 0;
			}
		}

		m_hPrevWnd	= hCurrentWnd;
		bC_x		= FALSE;
		bM_			= FALSE;
		nRepeat		= 0;

		m_OsVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&m_OsVersionInfo);

		if (strcmp(szApplicationName, szApplicationNameOrg)) {
			m_CurrentDirection		= NA;
		}
	}

	if (IsDown(VK_CONTROL)) {
		if (bC_x) {
			if (!m_nEnable[nApp][CONTROLX][wParam] && !m_nEnable[nApp][CONTROL][wParam]) {
				goto DO_NOTHING;
			} else if (!m_nEnable[nApp][CONTROLX][wParam]) {
				bC_x = FALSE;
			}
		} else if (!m_nEnable[nApp][CONTROL][wParam]) {
			goto DO_NOTHING;
		}
	} else if (IsDown(VK_MENU) || bM_) {
		if (!m_nEnable[nApp][META][wParam])
			goto DO_NOTHING;
	} else {
		if (!m_nEnable[nApp][NONE][wParam])
			if (!nRepeat) {
				goto DO_NOTHING;
			} else {
				ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
				Kdu((BYTE)wParam, nRepeat);
				goto HOOK;
			}
	}

	m_bRightControl	= IsDown(VK_RCONTROL);
	m_bRightAlt		= IsDown(VK_RMENU);
	m_bRightShift	= IsDown(VK_RSHIFT);

	// C-?
	if (IsDown(VK_CONTROL)) {
		switch (wParam) {
		case 'A':
			// C-a: Home
			CuKduCd(VK_HOME);
			goto HOOK;

		case 'B':
			// C-b: Left
			CuKduCd(VK_LEFT, nRepeat);
			goto HOOK;

		case 'C':
			// C-x C-c: Alt-F4
			if (bC_x) {
				if (strnicmp(szApplicationName, "explorer.exe", sizeof(szApplicationName)))
					CuAdKduKduAuCd(VK_SPACE, 'C');
				else
					CuAdKduAuCd(VK_F4);
				goto HOOK;
			} else
				break;

		case 'D':
			// C-d: Delete
			CuKduCd(VK_DELETE, nRepeat);
			goto HOOK;

		case 'E':
			// C-e: End
			CuKduCd(VK_END);
			goto HOOK;

		case 'F':
			// C-x C-f: Alt-F, Alt-O
			if (bC_x) {
				bOriginalM_f = TRUE;
				CuAdKduKduAuCd('F', 'O');
				goto HOOK;
			}

			// Ctrl-F: Find...
			else if (bOriginalC_f) {
				bOriginalC_f = FALSE;
				goto DO_NOTHING;
			}

			// C-f: Right		
			else {
				CuKduCd(VK_RIGHT, nRepeat);
				goto HOOK;
			}

		case 'G':
			// C-g: Keyboard quit
			goto HOOK;

		case 'H':
			// C-h: Back space
			CuKduCd(VK_BACK, nRepeat);
			goto HOOK;

		case 'I':
			// C-i: Tab
			CuKduCd(VK_TAB);
			goto HOOK;

		case 'J':
			// C-x C-j: Toggle IME
			if (bC_x) {
				ToggleIME();
				goto HOOK;
			} else
				break;

		case 'K':
			// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
			//		Shift-Right, Cut, if the cursor is at EOL
			if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
				// C-k: Shift-End, Control-x
				CuSdKduSuCd(VK_END);
				Kdu('W');
				goto HOOK;
			}

			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				static CString szClipboardText;

				switch (nStep) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();

					if (!CopyNextCharacter())
						goto DO_NOTHING;
					nStep = 1;
					goto RECURSIVE;
				case 1:
					nStep = 0;

					szClipboardText.Empty();
					GetClipboardText(&szClipboardText);

//					{
//						CString sz;
//						sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//						AfxMessageBox(sz);
//					}

					if (szClipboardText.IsEmpty()) {	// EOF
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_RIGHT);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName))) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_DOWN);
							CuSdKduSuCd(VK_HOME);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else {
							// default
							CuKduCd(VK_RIGHT);
							if (!SetClipboardText(&szOriginalClipboardText)) {
								//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
							}
							goto HOOK;
						}
					}

					if (szClipboardText.GetAt(0) != VK_RETURN) {
						CuSdKduKduSuCd(VK_END, VK_DELETE);

						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
						}

//						CuSdKduSuCd(VK_END);
//						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
//							CuSdKduSuCd(VK_LEFT);
//						}
//						Kdu('W');
					} else {
						CuSdKduSuCd(VK_RIGHT);
						Kdu('W');
					}

					nStep = 2;
					goto RECURSIVE;
				case 2:
					{
						nStep = 0;
						szClipboardText.Empty();
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//						AfxMessageBox(sz);

						int nEnter = szClipboardText.Find(VK_RETURN, 1);
						if ( nEnter != -1 ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
							szClipboardText = szClipboardText.Left(nEnter);
						}

						nStep = 3;
						goto RECURSIVE;
					}
				case 3:
					nStep = 0;
					if (!szClipboardText.IsEmpty())
						if (!SetClipboardText(&szClipboardText)) {
							//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
						}
					goto HOOK;
					break;
				}
			}

		case 'L':
			// C-l: Recenter
			if (!strnicmp(szApplicationName, "b2.exe", sizeof(szApplicationName))) {
				static int nStep = 0;
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				static int gap = INT_MAX;

				static POINT CaretPos;
				GetCaretPos(&CaretPos);

				switch(nStep) {
				case 0:
					nStep = 0;	// omaginai
					if (CaretPos.y < ClientRect.bottom / 2)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					else if (ClientRect.bottom / 2 < CaretPos.y)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					else {
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					CuKduCd(VK_DOWN);
					nStep = 1;
					goto RECURSIVE;

				case 1:
					nStep = 0;
					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					gap = newgap;
					goto RECURSIVE;
				}
			}
			else
			{
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				int gap = INT_MAX;

				for (;;) {
					POINT CaretPos;
					GetCaretPos(&CaretPos);

					if (CaretPos.y < ClientRect.bottom / 2)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					else if (ClientRect.bottom / 2 < CaretPos.y)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					else
						break;

					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						break;
					}
					gap = newgap;
				}
				goto HOOK;
			}

		case 'M':
			// C-m: Enter
			CuKduCd(VK_RETURN, nRepeat);
			goto HOOK;

		case 'N':
			// C-n: Down
			CuKduCd(VK_DOWN, nRepeat);
			goto HOOK;

		case 'O':
			// Ctrl-o: Open...
			if (bOriginalC_o) {
				bOriginalC_o = FALSE;
				goto DO_NOTHING;
			}

			// C-o: Toggle IME
			else {
				ToggleIME();
				goto HOOK;
			}

		case 'P':
			// C-x C-p: Ctrl-End, Ctrl-Shift-Home
			if (bC_x) {
				Kdu(VK_END);
				DepressKey(VK_SHIFT);
				Kdu(VK_HOME);
				ReleaseKey(VK_SHIFT);
				goto HOOK;
			}

			// C-p: Up
			CuKduCd(VK_UP, nRepeat);
			goto HOOK;

		case 'R':
			Search(BACKWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			goto HOOK;

		case 'S':
			// C-x C-s: Alt-F, Alt-S
			if (bC_x) {
				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
					// M$ Word
					bC_x = FALSE;
					goto DO_NOTHING;
				} else {
					// default
					bOriginalM_f = TRUE;
					CuAdKduKduAuCd('F', 'S');
					goto HOOK;
				}
			}

			// C-s:
			Search(FORWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			goto HOOK;

		case 'T':
			// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
			//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				switch (nStep) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();
//					AfxMessageBox(szOriginalClipboardText);

					// simple version
					if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
						// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
						ReleaseKey(VK_CONTROL);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						Kdu(VK_DELETE);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_INSERT);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						DepressKey(VK_CONTROL);
						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				
					if (!CopyBackCharacter())
						goto DO_NOTHING;

					nStep = 1;
					goto RECURSIVE;
					break;	// needless
				case 1:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						// Top Of File
						if (szClipboardText.IsEmpty() ||		// for normal application
							szClipboardText.GetLength() >= 3) {	// for VC++
							CuKduCd(VK_LEFT);
							nStep = 3;
							goto RECURSIVE;
						}

						if (!CopyNextCharacter()) {
							nStep = 3;
							goto RECURSIVE;
						}

						nStep = 2;
						goto RECURSIVE;
						break;	// needless
					}
				case 2:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						if (!szClipboardText.IsEmpty() &&
							szClipboardText.GetAt(0) != VK_RETURN) {
							ReleaseKey(VK_CONTROL);
							DepressKey(VK_SHIFT);
							Kdu(VK_LEFT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							DepressKey(VK_CONTROL);
						} else {
							if (szClipboardText.IsEmpty())	// EOF
								if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
									// These applications say "EOL is EOF".
									CuKduCd(VK_END);
								} else {
									// default
									CuKduCd(VK_RIGHT);
								}

							ReleaseKey(VK_CONTROL);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_CONTROL);
						}

						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				case 3:
					nStep = 0;
					if (!SetClipboardText(&szOriginalClipboardText)) {
						//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					}
					goto HOOK;
					break;	// needless
				}
			}

		case 'V':
			// Ctrl-V: Paste
			if (bOriginalC_v) {
				bOriginalC_v = FALSE;
				goto DO_NOTHING;
			}

			// C-v: Page Down
			else {
				CuKduCd(VK_NEXT, nRepeat);
				goto HOOK;
			}

		case 'W':
			// C-x C-w: Alt-F, Alt-A
			if (bC_x) {
				bOriginalM_f = TRUE;
				CuAdKduKduAuCd('F', 'A');
				goto HOOK;
			}

			// C-w: Ctrl-X
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
			bOriginalC_x = TRUE;
			Kdu('X');
			goto HOOK;

		case 'X':
			// Ctrl-X: Cut
			if (bOriginalC_x) {
				bOriginalC_x = FALSE;
				goto DO_NOTHING;
			}

			// C-x: only set flag
			else {
				bC_x = TRUE;
				goto HOOKX;
			}

		case 'Y':
			// C-y: Ctrl-V
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
			bOriginalC_v = TRUE;
			Kdu('V');
			goto HOOK;

		case 'Z':
			// Ctrl-Z: Undo
			if (bOriginalC_z) {
				bOriginalC_z = FALSE;
				goto DO_NOTHING;
			}

			// C-z: Alt-Space, Alt-N
			else {
				CuAdKduKduAuCd(VK_SPACE, 'N');
				goto HOOK;
			}

		case VK_SPACE:
			// C-space: Shift
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
			else
				DepressKey(VK_SHIFT);
			goto HOOK;

		case VK_OEM_4:	// 0xDB	Used for miscellaneous characters; it can vary by keyboard. 
						//		Windows 2000/XP: For the US standard keyboard, the '[{' key
			bM_ = TRUE;
			goto HOOKX;

		case 0xBF:
			// C-/: Ctrl-Z
			if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				goto HOOK;
			}
			bOriginalC_z = TRUE;
			Kdu('Z');
			goto HOOK;

		case 0xDC:	// C-\: Toggle IME
		case 0xE2:	// C-BACKSLASH of 106/109 keyboard: Toggle IME
			ToggleIME();
			goto HOOK;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// C-0...9
			nRepeat = nRepeat * 10 + (wParam - '0');
			goto HOOK0_9;

		default:
			ASSERT(0);
			break;
		}	// switch (wParam)
	}	// if (IsDown(VK_CONTROL))

	// M-?
	if (IsDown(VK_MENU) || bM_) {
		if (M_Foo(wParam, nRepeat, &bOriginalM_b, &bOriginalM_f))
			goto HOOK;
		goto DO_NOTHING;
	}

	switch (wParam) {
		case 'U':
			// C-x u: Ctrl-Z
			if (bC_x) {
				DepressKey(VK_CONTROL);
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				ReleaseKey(VK_CONTROL);
				goto HOOK;
			}
			goto DO_NOTHING;

		case VK_ESCAPE:
			bM_ = TRUE;
			goto DO_NOTHING;

		default:
			ASSERT(0);
			break;
	}

DO_NOTHING:
	return ::CallNextHookEx(m_hHook, code, wParam, lParam);

RECURSIVE:
//	LRESULT result;
//	result = ::CallNextHookEx(m_hHook, code, wParam, lParam);
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
	Kdu((BYTE)wParam);
//	return result;
	return TRUE;

HOOK:
	nRepeat	= 0;
HOOK0_9:
	bC_x	= FALSE;
	bM_		= FALSE;
HOOKX:
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsData Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsData::CXkeymacsData()
{
	ClearAll();
}

CXkeymacsData::~CXkeymacsData()
{

}

// set application name
void CXkeymacsData::SetApplicationName(LPCTSTR lpszApplicationName)
{
	m_strApplicationName.Format(lpszApplicationName);
}

// return application name
CString CXkeymacsData::GetApplicationName()
{
	return m_strApplicationName;
}

// set hook or not
void CXkeymacsData::SetEnable(int nCommandType, int nKey, int nEnable)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	m_nEnable[nCommandType][nKey] = nEnable;
}

// return hook or not
int CXkeymacsData::GetEnable(int nCommandType, int nKey)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	return m_nEnable[nCommandType][nKey];
}

// clear all data
void CXkeymacsData::ClearAll()
{
	ZeroMemory(m_nEnable, sizeof(m_nEnable));
	m_strApplicationName.Empty();
}

// set application name
void CXkeymacsDll::SetApplicationName(int nApp, CString szApplicationName)
{
	ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
	strncpy(m_szSpecialApp[nApp], szApplicationName, sizeof(m_szSpecialApp[nApp]));
}

// return root window of focused window
HWND CXkeymacsDll::GetFocusRoot()
{
	HWND hWnd, hRootWnd;
	for (hRootWnd = hWnd = GetFocus(); hWnd; hWnd = GetParent(hWnd))
		hRootWnd = hWnd;
	return hRootWnd;
}

// set m_nEnable[nApp][nCommandType][nKey] nEnable
void CXkeymacsDll::SetEnable(int nApp, int nCommandType, int nKey, int nEnable)
{
	m_nEnable[nApp][nCommandType][nKey] = nEnable;
}

// Clear data of nApp
void CXkeymacsDll::Clear(int nApp)
{
	if (0 <= nApp && nApp < MAX_APP) {
		ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
		ZeroMemory(m_nEnable[nApp], sizeof(m_nEnable[nApp]));
	} else
		ASSERT(0);
}

// Set m_hPrevWnd 0 for that KeyboardProc() updates data 
void CXkeymacsDll::UpdateData()
{
	m_hPrevWnd = 0;
}

void CXkeymacsData::SetApplicationTitle(LPCTSTR lpszApplicationTitle)
{
	m_strApplicationTitle.Format(lpszApplicationTitle);
}

CString CXkeymacsData::GetApplicationTitle()
{
	return m_strApplicationTitle;
}

BOOL CXkeymacsDll::GetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard");
		return FALSE;
	}

	HANDLE hClipboardText;
//	if ((hClipboardText = ::GetClipboardData(CF_TEXT)) == NULL) {
	if ((hClipboardText = ::GetClipboardData(CF_OEMTEXT)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to get Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	szClipboardText->Format("%s", hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CXkeymacsDll::SetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard in SetClipboardText");
		return FALSE;
	}

	int nLength = szClipboardText->GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nLength);
	if (hClipboardText == NULL) {
//		AfxMessageBox("Failed: GlobalAlloc in SetClipboardText");
		return FALSE;
	}

	LPSTR lpStr = (LPSTR)GlobalLock(hClipboardText);
	lstrcpyn(lpStr, *szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	if ((hClipboardText = ::SetClipboardData(CF_OEMTEXT, hClipboardText)) == NULL) {
//		DWORD dw = GetLastError();
//		CString szMessage;
//		szMessage.Format("Unable to set Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;

}

BOOL CXkeymacsDll::M_Foo(WPARAM wParam, int nRepeat, BOOL *bOriginalM_b, BOOL *bOriginalM_f)
{
	BOOL bIsAltDown = IsDown(VK_MENU);

	switch (wParam) {
	case 'B':
		if (bIsAltDown)
			if (*bOriginalM_b) {
				*bOriginalM_b = FALSE;
				return FALSE;
			}

		// M-b: backward-word
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		CdKduCu(VK_LEFT, nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'F':
		if (bIsAltDown)
			if (*bOriginalM_f) {
				*bOriginalM_f = FALSE;
				return FALSE;
			}

		// M-f: forward-word
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		CdKduCu(VK_RIGHT, nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'V':
		// M-v: Page Up
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		Kdu(VK_PRIOR, nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'W':
		// M-w: Ctrl-C
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		if (IsDown(VK_SHIFT))
			ReleaseKey(VK_SHIFT);
		CdKduCu('C');

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case VK_OEM_COMMA:	// 0xBC Windows 2000/XP: For any country/region, the ',' key
		// M-<:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown)
				ReleaseKey(VK_MENU);

			ReleaseKey(VK_SHIFT);
			CdKduCu(VK_HOME);
			DepressKey(VK_SHIFT);

			if (bIsAltDown)
				DepressKey(VK_MENU);

			return TRUE;
		}
		break;

	case VK_OEM_PERIOD:	// 0xBE Windows 2000/XP: For any country/region, the '.' key
		// M->:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown)
				ReleaseKey(VK_MENU);

			ReleaseKey(VK_SHIFT);
			CdKduCu(VK_END);
			DepressKey(VK_SHIFT);

			if (bIsAltDown)
				DepressKey(VK_MENU);

			return TRUE;
		}
		break;

	case '1':
		// M-!: cmd.exe/command.com
		if (IsDown(VK_SHIFT)) {
			STARTUPINFO si;
			memset(&si, 0, sizeof(STARTUPINFO));
			PROCESS_INFORMATION pi;
			memset(&pi, 0, sizeof(PROCESS_INFORMATION));

			if (m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
				// Windows 95, Windows 98, or Windows Me. 
				CreateProcess(NULL, "command.com", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			} else {
				CreateProcess(NULL, "cmd.exe", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			}
			return TRUE;
		}
		break;

	default:
		if (bIsAltDown)
			ASSERT(0);
		break;
	}
	return FALSE;
}
