// xkeymacs.h: interface for the CXkeymacsDll class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
#define AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

HINSTANCE GetThisHInst();

enum {MAX_APP = 32};
enum {NONE, CONTROL, CONTROLX, META, MAX_COMMAND_TYPE};
enum {MAX_KEY = 256};

enum {WINDOW_NAME_LENGTH	= 128};
enum {CLASS_NAME_LENGTH		= 128};
enum {SUB_KEY_NAME_LENGTH	= 128};

enum SEARCH_DIRECTION {NA, FORWARD, BACKWARD};

class CSearchKey {
public:
	CSearchKey();
	CSearchKey(char* szApplicationName, int nApplicationNameLength, CString *szDialogTitle);
	BYTE bFindWhat;
	BYTE bDirectionForward;
	BYTE bDirectionBackward;
	BYTE bSearchOption;
};

class CSearch {
public:
	CSearch(char* szApplicationName, int nApplicationNameLength);
	CString szDialogTitle;
	CSearchKey* pKey;
};

class AFX_EXT_CLASS CXkeymacsDll  
{
public:
	void UpdateData();
	void Clear(int nApp);
	BOOL IsKeyboardHook();
	void SetEnable(int nApp, int nCommandType, int nKey, int nEnable);
	void SetApplicationName(int nApp, CString szApplicationName);
	BOOL ReleaseKeyboardHook();
	BOOL SetKeyboardHook();
	CXkeymacsDll();
	virtual ~CXkeymacsDll();

private:
	static BOOL IsDown(BYTE bVk);
	static BOOL M_Foo(WPARAM wParam, int nRepeat, BOOL *bOriginalM_b, BOOL *bOriginalM_f);
	static BOOL SetClipboardText(CString *szClipboardText);
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL GetClipboardText(CString *szClipboardText);
	static void ToggleIME();
	static void DoKeybd_event(BYTE bVk, DWORD dwFlags);
	static void DepressKey(BYTE bVk);
	static void ReleaseKey(BYTE bVk);
	static void Kdu(BYTE bVk, int n);
	static void CuKduCd(BYTE bVk, int n);
	static void CuKduKduCd(BYTE bVk1, BYTE bVk2);
	static void CuAdKduAuCd(BYTE bVk);
	static void CuAdKduKduAuCd(BYTE bVk1, BYTE bVk2);
	static void CuAdKduKduKduAuCd(BYTE bVk1, BYTE bVk2, BYTE bVk3);
	static void CuSdKduSuCd(BYTE bVk);
	static void CuSdKduKduSuCd(BYTE bVk1, BYTE bVk2);
	static void AuKduAd(BYTE bVk);
	static void CdKduCu(BYTE bVk, int n);
	static LRESULT CALLBACK KeyboardProc(int code, WPARAM wParam, LPARAM lParam);
	static HHOOK m_hHook;
protected:
	static BOOL m_bRightShift;
	static BOOL m_bRightAlt;
	static BOOL m_bRightControl;
	static SEARCH_DIRECTION m_CurrentDirection;
	static void SearchSetDirection(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength,
								   BOOL *bOriginalM_b, BOOL *bOriginalM_f, CSearch* pSearch);
	static void Search(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength, BOOL *bOriginalC_f, BOOL *bOriginalM_b, BOOL *bOriginalM_f);
	static OSVERSIONINFO m_OsVersionInfo;
	static HWND m_hPrevWnd;
	static char m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH];
	static int m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY];
	static HWND GetFocusRoot();
};


class AFX_EXT_CLASS CXkeymacsData  
{
public:
	CString GetApplicationTitle();
	void SetApplicationTitle(LPCTSTR lpszApplicationTitle);
	void ClearAll();
	int GetEnable(int nCommandType, int nKey);
	void SetEnable(int nCommandType, int nKey, int nEnable);
	CString GetApplicationName();
	void SetApplicationName(LPCTSTR lpszApplicationName);
	CXkeymacsData();
	virtual ~CXkeymacsData();

protected:
	CString m_strApplicationTitle;
	CString m_strApplicationName;
	int m_nEnable[MAX_COMMAND_TYPE][MAX_KEY];
};

#endif // !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
